CoordinationPermission
Date: 2016-06-25

org.osgi.service.coordinator

## Class CoordinationPermission

- java.lang.Object
- - java.security.Permission
  - - java.security.BasicPermission
    - - org.osgi.service.coordinator.CoordinationPermission

- All Implemented Interfaces:
    java.io.Serializable, java.security.Guard

      public final class CoordinationPermission
      extends java.security.BasicPermission

  A bundle's authority to create or use a `Coordination`.

  `CoordinationPermission` has three actions: `initiate`, `participate` and `admin`.

  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `ADMIN` The action string `admin`.
    `static java.lang.String` | `INITIATE` The action string `initiate`.
    `static java.lang.String` | `PARTICIPATE` The action string `participate`.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CoordinationPermission(java.lang.String coordinationName, org.osgi.framework.Bundle coordinationBundle, java.lang.String actions)` Creates a new requested `CoordinationPermission` object to be used by the code that must perform `checkPermission`.
    `CoordinationPermission(java.lang.String filter, java.lang.String actions)` Creates a new granted `CoordinationPermission` object.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(java.lang.Object obj)` Determines the equality of two `CoordinationPermission` objects.
    `java.lang.String` | `getActions()` Returns the canonical string representation of the `CoordinationPermission` actions.
    `int` | `hashCode()` Returns the hash code value for this object.
    `boolean` | `implies(java.security.Permission p)` Determines if the specified permission is implied by this object.
    `java.security.PermissionCollection` | `newPermissionCollection()` Returns a new `PermissionCollection` object suitable for storing `CoordinationPermission` objects.

    - ### Methods inherited from class java.security.Permission

      `checkGuard, getName, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### INITIATE

          public static final java.lang.String INITIATE

      The action string `initiate`.
      See Also:
        Constant Field Values

    - #### PARTICIPATE

          public static final java.lang.String PARTICIPATE

      The action string `participate`.
      See Also:
        Constant Field Values

    - #### ADMIN

          public static final java.lang.String ADMIN

      The action string `admin`.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### CoordinationPermission

          public CoordinationPermission(java.lang.String filter,
                                java.lang.String actions)

      Creates a new granted `CoordinationPermission` object. This constructor must only be used to create a permission that is going to be checked.

      Examples:

           (coordination.name=com.acme.*)
           (&(signer=\*,o=ACME,c=US)(coordination.name=com.acme.*))
           (signer=\*,o=ACME,c=US)

      When a signer key is used within the filter expression the signer value must escape the special filter chars ('*', '(', ')').

      The name is specified as a filter expression. The filter gives access to the following attributes:

      - signer - A Distinguished Name chain used to sign the exporting bundle. Wildcards in a DN are not matched according to the filter string rules, but according to the rules defined for a DN chain.
      - location - The location of the exporting bundle.
      - id - The bundle ID of the exporting bundle.
      - name - The symbolic name of the exporting bundle.
      - coordination.name - The name of the requested coordination.
      Filter attribute names are processed in a case sensitive manner.
      Parameters:
        `filter` - A filter expression. Filter attribute names are processed in a case sensitive manner. A special value of `"*"` can be used to match all coordinations.
        `actions` - `admin`, `initiate` or `participate` (canonical order).
      Throws:
        `java.lang.IllegalArgumentException` - If the filter has an invalid syntax.

    - #### CoordinationPermission

          public CoordinationPermission(java.lang.String coordinationName,
                                org.osgi.framework.Bundle coordinationBundle,
                                java.lang.String actions)

      Creates a new requested `CoordinationPermission` object to be used by the code that must perform `checkPermission`. `CoordinationPermission` objects created with this constructor cannot be added to an `CoordinationPermission` permission collection.
      Parameters:
        `coordinationName` - The name of the requested Coordination.
        `coordinationBundle` - The bundle which `created` the requested Coordination.
        `actions` - `admin`, `initiate` or `participate` (canonical order).

  - ### Method Detail

    - #### implies

          public boolean implies(java.security.Permission p)

      Determines if the specified permission is implied by this object.

      This method checks that the filter of the target is implied by the coordination name of this object. The list of `CoordinationPermission` actions must either match or allow for the list of the target object to imply the target `CoordinationPermission` action.

      Overrides:
        `implies` in class `java.security.BasicPermission`
      Parameters:
        `p` - The requested permission.
      Returns:
        `true` if the specified permission is implied by this object; `false` otherwise.

    - #### getActions

          public java.lang.String getActions()

      Returns the canonical string representation of the `CoordinationPermission` actions.

      Always returns present `CoordinationPermission` actions in the following order: `admin`, `initiate`, `participate`.

      Overrides:
        `getActions` in class `java.security.BasicPermission`
      Returns:
        Canonical string representation of the `CoordinationPermission` actions.

    - #### newPermissionCollection

          public java.security.PermissionCollection newPermissionCollection()

      Returns a new `PermissionCollection` object suitable for storing `CoordinationPermission` objects.
      Overrides:
        `newPermissionCollection` in class `java.security.BasicPermission`
      Returns:
        A new `PermissionCollection` object.

    - #### equals

          public boolean equals(java.lang.Object obj)

      Determines the equality of two `CoordinationPermission` objects. This method checks that specified permission has the same name and `CoordinationPermission` actions as this `CoordinationPermission` object.
      Overrides:
        `equals` in class `java.security.BasicPermission`
      Parameters:
        `obj` - The object to test for equality with this `CoordinationPermission` object.
      Returns:
        `true` if `obj` is a `CoordinationPermission`, and has the same name and actions as this `CoordinationPermission` object; `false` otherwise.

    - #### hashCode

          public int hashCode()

      Returns the hash code value for this object.
      Overrides:
        `hashCode` in class `java.security.BasicPermission`
      Returns:
        A hash code value for this object.